library flrouter;

import 'package:flutter/material.dart';
import 'package:uri/uri.dart';

typedef Widget FlrouterBuilder(BuildContext context, UriMatch match);

class Flrouter {
  static final instance = Flrouter();

  final routes = Map<String, FlrouterBuilder>();

  void define(String route, {@required FlrouterBuilder builder}) {
    routes.putIfAbsent(route, () => builder);
  }

  Route<dynamic> generator(RouteSettings settings) {
    final route = routes.keys.where((route) => UriParser(UriTemplate(route)).matches(Uri.parse(settings.name))).first;
    
    return MaterialPageRoute(settings: settings, builder: (context)=> routes[route](context, UriParser(UriTemplate(route)).match(Uri.parse(settings.name))));
  }
}